-- tab size is 4
-- registrations for media from the client itself belongs in LibSharedMedia-3.0

local LSM = LibStub("LibSharedMedia-3.0")

-- -----
-- BACKGROUND
-- -----
LSM:Register("background", "Moo", [[Interface\Addons\SharedMedia\background\moo.tga]])
LSM:Register("background", "Bricks", [[Interface\Addons\SharedMedia\background\bricks.tga]])
LSM:Register("background", "Brushed Metal", [[Interface\Addons\SharedMedia\background\brushedmetal.tga]])
LSM:Register("background", "Copper", [[Interface\Addons\SharedMedia\background\copper.tga]])
LSM:Register("background", "Smoke", [[Interface\Addons\SharedMedia\background\smoke.tga]])

-- -----
--  BORDER
-- ----
LSM:Register("border", "RothSquare", [[Interface\Addons\SharedMedia\border\roth.tga]])
LSM:Register("border", "SeerahScalloped", [[Interface\Addons\SharedMedia\border\SeerahScalloped.blp]])

-- -----
--   FONT
-- -----
-- all fonts have been removed from SharedMedia for the moment
-- fonts using a license that allows redistribution will most likely be readded later
LSM:Register("font", "Adventure",					[[Interface\Addons\SharedMedia\fonts\Adventure.ttf]])
--~ LSM:Register("font", "ABF",							[[Interface\Addons\SharedMedia\fonts\ABF.ttf]])
LSM:Register("font", "Bazooka",						[[Interface\Addons\SharedMedia\fonts\Bazooka.ttf]])
--~ LSM:Register("font", "BigNoodleTitling",			[[Interface\Addons\SharedMedia\fonts\BigNoodleTitling.ttf]])
--~ LSM:Register("font", "BigNoodleTitling-Oblique",	[[Interface\Addons\SharedMedia\fonts\BigNoodleTitling-Oblique.ttf]])
LSM:Register("font", "Black Chancery",				[[Interface\Addons\SharedMedia\fonts\BlackChancery.ttf]])
--~ LSM:Register("font", "Diablo",						[[Interface\Addons\SharedMedia\fonts\Avqest.ttf]])
--~ LSM:Register("font", "Emblem",						[[Interface\Addons\SharedMedia\fonts\Emblem.ttf]])
LSM:Register("font", "Enigmatic",						[[Interface\Addons\SharedMedia\fonts\Enigma__2.ttf]])
LSM:Register("font", "Movie Poster",				[[Interface\Addons\SharedMedia\fonts\SFMoviePoster-Bold.ttf]])
--~ LSM:Register("font", "Porky's",						[[Interface\Addons\SharedMedia\fonts\Porky.ttf]])
--~ LSM:Register("font", "RM Midserif",					[[Interface\Addons\SharedMedia\fonts\rm_midse.ttf]])
--~ LSM:Register("font", "Tangerine",					[[Interface\Addons\SharedMedia\fonts\Tangerin.ttf]])
--~ LSM:Register("font", "TwCenMT",						[[Interface\Addons\SharedMedia\fonts\Tw_Cen_MT_Bold.ttf]])
--~ LSM:Register("font", "Ultima Campagnoli",			[[Interface\Addons\SharedMedia\fonts\Ultima_Campagnoli.ttf]])
LSM:Register("font", "Vera Serif",					[[Interface\Addons\SharedMedia\fonts\VeraSe.ttf]])
LSM:Register("font", "Yellowjacket",				[[Interface\Addons\SharedMedia\fonts\YELLOWJACKET.ttf]])
LSM:Register("font", "DorisPP",				[[Interface\Addons\SharedMedia\fonts\DORISPP.ttf]])
LSM:Register("font", "Fitzgerald",				[[Interface\Addons\SharedMedia\fonts\Fitzgerald.ttf]])
LSM:Register("font", "Gentium",				[[Interface\Addons\SharedMedia\fonts\Gentium.ttf]])
LSM:Register("font", "Hooked Up",				[[Interface\Addons\SharedMedia\fonts\HookedUp.ttf]])
LSM:Register("font", "Liberation Sans",				[[Interface\Addons\SharedMedia\fonts\LiberationSans.ttf]])
LSM:Register("font", "Atarian System",				[[Interface\Addons\SharedMedia\fonts\SFAtarianSystem.ttf]])
LSM:Register("font", "Covington",				[[Interface\Addons\SharedMedia\fonts\SFCovington.ttf]])
LSM:Register("font", "Wonder Comic",				[[Interface\Addons\SharedMedia\fonts\SFWonderComic.ttf]])
LSM:Register("font", "swf!t",				[[Interface\Addons\SharedMedia\fonts\swfit.ttf]])

-- -----
--   SOUND
-- -----

-- -----
--   STATUSBAR
-- -----
LSM:Register("statusbar", "Aluminium",			[[Interface\Addons\SharedMedia\statusbar\Aluminium]])
LSM:Register("statusbar", "Armory",				[[Interface\Addons\SharedMedia\statusbar\Armory]])
LSM:Register("statusbar", "BantoBar",			[[Interface\Addons\SharedMedia\statusbar\BantoBar]])
LSM:Register("statusbar", "Bars",				[[Interface\Addons\SharedMedia\statusbar\Bars]])
LSM:Register("statusbar", "Bumps",				[[Interface\Addons\SharedMedia\statusbar\Bumps]])
LSM:Register("statusbar", "Button",				[[Interface\Addons\SharedMedia\statusbar\Button]])
LSM:Register("statusbar", "Charcoal",			[[Interface\Addons\SharedMedia\statusbar\Charcoal]])
LSM:Register("statusbar", "Cilo",				[[Interface\Addons\SharedMedia\statusbar\Cilo]])
LSM:Register("statusbar", "Cloud",				[[Interface\Addons\SharedMedia\statusbar\Cloud]])
LSM:Register("statusbar", "Comet",				[[Interface\Addons\SharedMedia\statusbar\Comet]])
LSM:Register("statusbar", "Dabs",				[[Interface\Addons\SharedMedia\statusbar\Dabs]])
LSM:Register("statusbar", "DarkBottom",			[[Interface\Addons\SharedMedia\statusbar\DarkBottom]])
LSM:Register("statusbar", "Diagonal",			[[Interface\Addons\SharedMedia\statusbar\Diagonal]])
LSM:Register("statusbar", "Empty",			    [[Interface\Addons\SharedMedia\statusbar\Empty]])
LSM:Register("statusbar", "Falumn",				[[Interface\Addons\SharedMedia\statusbar\Falumn]])
LSM:Register("statusbar", "Fifths",				[[Interface\Addons\SharedMedia\statusbar\Fifths]])
LSM:Register("statusbar", "Flat",				[[Interface\Addons\SharedMedia\statusbar\Flat]])
LSM:Register("statusbar", "Fourths",			[[Interface\Addons\SharedMedia\statusbar\Fourths]])
LSM:Register("statusbar", "Frost",				[[Interface\Addons\SharedMedia\statusbar\Frost]])
LSM:Register("statusbar", "Glamour",			[[Interface\Addons\SharedMedia\statusbar\Glamour]])
LSM:Register("statusbar", "Glamour2",			[[Interface\Addons\SharedMedia\statusbar\Glamour2]])
LSM:Register("statusbar", "Glamour3",			[[Interface\Addons\SharedMedia\statusbar\Glamour3]])
LSM:Register("statusbar", "Glamour4",			[[Interface\Addons\SharedMedia\statusbar\Glamour4]])
LSM:Register("statusbar", "Glamour5",			[[Interface\Addons\SharedMedia\statusbar\Glamour5]])
LSM:Register("statusbar", "Glamour6",			[[Interface\Addons\SharedMedia\statusbar\Glamour6]])
LSM:Register("statusbar", "Glamour7",			[[Interface\Addons\SharedMedia\statusbar\Glamour7]])
LSM:Register("statusbar", "Glass",				[[Interface\Addons\SharedMedia\statusbar\Glass]])
LSM:Register("statusbar", "Glaze",				[[Interface\Addons\SharedMedia\statusbar\Glaze]])
LSM:Register("statusbar", "Glaze v2",			[[Interface\Addons\SharedMedia\statusbar\Glaze2]])
LSM:Register("statusbar", "Gloss",				[[Interface\Addons\SharedMedia\statusbar\Gloss]])
LSM:Register("statusbar", "Graphite",			[[Interface\Addons\SharedMedia\statusbar\Graphite]])
LSM:Register("statusbar", "Grid",				[[Interface\Addons\SharedMedia\statusbar\Grid]])
LSM:Register("statusbar", "Hatched",			[[Interface\Addons\SharedMedia\statusbar\Hatched]])
LSM:Register("statusbar", "Healbot",			[[Interface\Addons\SharedMedia\statusbar\Healbot]])
LSM:Register("statusbar", "Lyfe",				[[Interface\Addons\SharedMedia\statusbar\Lyfe]])
LSM:Register("statusbar", "LiteStep",			[[Interface\Addons\SharedMedia\statusbar\LiteStep]])
LSM:Register("statusbar", "LiteStepLite",		[[Interface\Addons\SharedMedia\statusbar\LiteStepLite]])
LSM:Register("statusbar", "Melli",				[[Interface\Addons\SharedMedia\statusbar\Melli]])
LSM:Register("statusbar", "Melli Dark",			[[Interface\Addons\SharedMedia\statusbar\MelliDark]])
LSM:Register("statusbar", "Melli Dark Rough",	[[Interface\Addons\SharedMedia\statusbar\MelliDarkRough]])
LSM:Register("statusbar", "Minimalist",			[[Interface\Addons\SharedMedia\statusbar\Minimalist]])
LSM:Register("statusbar", "Otravi",				[[Interface\Addons\SharedMedia\statusbar\Otravi]])
LSM:Register("statusbar", "Outline",			[[Interface\Addons\SharedMedia\statusbar\Outline]])
LSM:Register("statusbar", "Perl",				[[Interface\Addons\SharedMedia\statusbar\Perl]])
LSM:Register("statusbar", "Perl v2",			[[Interface\Addons\SharedMedia\statusbar\Perl2]])
LSM:Register("statusbar", "Pill",				[[Interface\Addons\SharedMedia\statusbar\Pill]])
LSM:Register("statusbar", "Rain",				[[Interface\Addons\SharedMedia\statusbar\Rain]])
LSM:Register("statusbar", "Rocks",				[[Interface\Addons\SharedMedia\statusbar\Rocks]])
LSM:Register("statusbar", "Round",				[[Interface\Addons\SharedMedia\statusbar\Round]])
LSM:Register("statusbar", "Ruben",				[[Interface\Addons\SharedMedia\statusbar\Ruben]])
LSM:Register("statusbar", "Runes",				[[Interface\Addons\SharedMedia\statusbar\Runes]])
LSM:Register("statusbar", "Skewed",				[[Interface\Addons\SharedMedia\statusbar\Skewed]])
LSM:Register("statusbar", "Smooth",				[[Interface\Addons\SharedMedia\statusbar\Smooth]])
LSM:Register("statusbar", "Smooth v2",			[[Interface\Addons\SharedMedia\statusbar\Smoothv2]])
LSM:Register("statusbar", "Smudge",				[[Interface\Addons\SharedMedia\statusbar\Smudge]])
LSM:Register("statusbar", "Steel",				[[Interface\Addons\SharedMedia\statusbar\Steel]])
LSM:Register("statusbar", "Striped",			[[Interface\Addons\SharedMedia\statusbar\Striped]])
LSM:Register("statusbar", "Tube",				[[Interface\Addons\SharedMedia\statusbar\Tube]])
LSM:Register("statusbar", "Water",				[[Interface\Addons\SharedMedia\statusbar\Water]])
LSM:Register("statusbar", "Wglass",				[[Interface\Addons\SharedMedia\statusbar\Wglass]])
LSM:Register("statusbar", "Wisps",				[[Interface\Addons\SharedMedia\statusbar\Wisps]])
LSM:Register("statusbar", "Xeon",				[[Interface\Addons\SharedMedia\statusbar\Xeon]])
